#!/usr/bin/perl
#
# $Header: //sapdb/V76/c_00/b_34/sys/src/install/perl/SAPDB/Install/Control/Link.pm#1 $
# $DateTime: 2006/09/04 17:37:38 $
# $Change: 134683 $
#
# Desc: 

package SAPDB::Install::Control::Link;

use Wx::Event qw (
	EVT_LEFT_DOWN EVT_LEFT_UP EVT_LEFT_DCLICK
	EVT_ENTER_WINDOW EVT_LEAVE_WINDOW);

use Wx qw(
	wxDECORATIVE wxNORMAL wxICON_ERROR wxHORIZONTAL
	wxEVT_COMMAND_BUTTON_CLICKED wxWANTS_CHARS
	wxALIGN_CENTER 	wxLEFT wxRIGHT);

use SAPDB::Install::Control::StaticText;
use SAPDB::Install::Control::StaticBitmap;

our @ISA = qw (Wx::Panel);

sub new{
	my($this ) = shift->SUPER::new(@_);
	$this->SetWindowStyleFlag(wxWANTS_CHARS);
	$this->SetBackgroundColour($this->GetParent->GetBackgroundColour);
	my $sizer; 
	if($^O =~ /mswin/i){
		$this->{'sbox'} = Wx::StaticBox->new($this,-1,'');
		$sizer = Wx::StaticBoxSizer->new($this->{'sbox'},wxHORIZONTAL);
		$this->{'sbox'}->Show(0);
		$this->{'sbox'}->SetNextHandler($this);
	}
	else{
		$sizer = Wx::BoxSizer->new(wxHORIZONTAL);
	}
	$this->{'txtctrl'} = SAPDB::Install::Control::StaticText->new($this,-1);
	$this->{'txtctrl'}->SetNextHandler($this);
	$this->{'txtctrl'}->{'font'} = Wx::Font->new(11,$^O =~ /mswin/i ? wxNORMAL : wxDECORATIVE, wxNORMAL, wxNORMAL, 0 );
	$this->{'enter_count'} = 0;
	EVT_LEFT_DOWN($this,\&OnLeftDown);
	EVT_LEFT_UP($this,\&OnLeftUp);
	EVT_LEFT_DCLICK($this,\&OnDClick);
	EVT_ENTER_WINDOW($this,\&OnEnter);
	EVT_LEAVE_WINDOW($this,\&OnLeave); 	
	$this->SetNextHandler($this->GetParent);
	$this->SetSizer($sizer);
	return $this;
}

sub OnEnter{
	my ($self,$evt) = @_;
	$self->{'enter_count'}++;
	$self->select;
}

sub OnLeave{
	my ($self,$evt) = @_;
	if($self->{'enter_count'} > 0){
		$self->{'enter_count'}--;
	}
	$self->unselect if $self->{'enter_count'} == 0;
}

sub OnLeftDown{
	my ($self,$event) = @_;
	$self->{'down'} = 1;	
}

sub OnLeftUp{
	my ($self,$event) = @_;
	if($self->{'down'}){
		$self->Call;
		$self->{'down'} = 0;	
	}
}



sub OnDClick{
	my ($self,$event) = @_;
	$self->Call;
}


sub setText{
	my ($self,$text) = @_;
	$self->GetSizer->Remove($self->{'txtctrl'});
	$self->{'txtctrl'}->{'text_colour'} = Wx::Colour->new(150,150,150);
	$self->{'txtctrl'}->{'itext_colour'} = Wx::Colour->new(0,0,0);
	$self->{'txtctrl'}->{'ibg_colour'} = Wx::Colour->new(255,255,255);
	$self->{'txtctrl'}->setText($text);
	$self->GetSizer->Add($self->{'txtctrl'},0,wxALIGN_CENTER | wxRIGHT,10);
	$self->Layout;
}

sub select{
	my ($self) = @_;
	return if $self->{'selected'}; 
	unless(defined $self->{'command_event'}){
		$self->{'command_event'} = Wx::CommandEvent->new(wxEVT_COMMAND_BUTTON_CLICKED,$self->GetId);
	}
	$self->{'txtctrl'}->setInvers;
	$self->{'sbmp'}->Invert();
	$self->GetParent->AddPendingEvent($self->{'command_event'});
	$self->{'sbox'}->Show(1) if ($^O =~ /mswin/i);
	$self->{'selected'} = 1;
	my $fwin = Wx::Window::FindFocus(); 
	if(defined $fwin and Wx::GetTopLevelParent($fwin)->GetId == Wx::GetTopLevelParent($self)->GetId){
		$self->SetFocus;
	}
}

sub unselect{
	my ($self) = @_;
	return unless $self->{'selected'};
	$self->{'txtctrl'}->setInvers;
	$self->{'sbmp'}->Invert();
	$self->{'sbox'}->Show(0) if ($^O =~ /mswin/i);
	$self->{'selected'} = 0;
}

sub setImg{
	my ($self,$img) = @_;
	#$self->{'img'} = $img->Copy;
	#$img->Rescale(32,32);
	#$self->GetSizer->Remove($self->{'sbmp'});
	#$self->{'sbmp'} = Wx::StaticBitmap->new($self,-1,Wx::Bitmap->new($self->{'img'}));
	#$self->{'sbmp'}->SetNextHandler($self);
	$self->{'sbmp'} = SAPDB::Install::Control::StaticBitmap->new($self,-1);
	$self->{'sbmp'}->SetBmpFromImage($img);
	$self->{'sbmp'}->Invert();
	$self->{'sbmp'}->SetNextHandler($self);
	$self->GetSizer->Prepend($self->{'sbmp'},0,wxALIGN_CENTER | wxLEFT | wxRIGHT, 10);
	$self->Layout;
}

sub Call{
	my ($self,$args) = @_;
	my $browser = '"C:\Program Files\Internet Explorer\IEXPLORE.EXE"';
	if(defined $self->{'cmd_func'}){
		my @argv = ();
		if(defined $args){
			push @argv,@$args;
		}
		if(defined $self->{'cmd_args'}){
			push @argv,@{$self->{'cmd_args'}};
		}
		&{$self->{'cmd_func'}}(@argv);
	}
	elsif($self->{'link'} =~ /\S/){
		`$browser $self->{'link'}`;
		
	}
	else{
		my $msgbox = Wx::MessageDialog->new($self,"Icon \"".$self->{'txtctrl'}->{'text'}."\" has no Cmd Function Reference!\n",
						"Error: Icon Call", wxICON_ERROR | wxCENTRE);
		$msgbox->ShowModal();
	}
}

sub SetToolTip{
	my ($self,$text) = @_;
	$self->{'sbmp'}->SetToolTip($text);
	$self->{'txtctrl'}->SetToolTip($text);
	$self->SUPER::SetToolTip($text);
}

sub Destroy{
	my ($self) = @_;
	$self->GetSizer->Remove($self->{'sbmp'}) if exists $self->{'sbmp'};
	$self->GetSizer->Remove($self->{'txtctrl'});
	$self->{'sbmp'}->Destroy if exists $self->{'sbmp'};
	delete $self->{'sbmp'};
	$self->{'txtctrl'}->Destroy;
	delete $self->{'txtctrl'};
	$self->SUPER::Destroy;

}

sub DESTROY{
	my ($self) = @_;
	print ">>>> destroying $self\n"
		if $SAPDB::Install::DEBUG::DESTRUCT;
}


1;