#!/usr/bin/perl
#
# $Header: //sapdb/V76/develop/sys/src/install/perl/SAPDB/Install/Dialog/PackageView.pm#2 $
# $DateTime: 2004/09/30 12:05:26 $
# $Change: 81077 $
#
# Desc: 


package SAPDB::Install::Dialog::Uninstall;

use Wx::Event qw (EVT_CLOSE);
use Wx qw ( wxVERTICAL
	wxEXPAND wxALIGN_CENTER wxALL
	wxTOP wxBOTTOM wxYES_NO wxNO_DEFAULT
	wxICON_QUESTION wxCENTRE wxID_YES
	wxMAXIMIZE_BOX	wxDEFAULT_DIALOG_STYLE);

use base Wx::Dialog;
use SAPDB::Install::Window::Uninstall;
use SAPDB::Install::Resources;

our $icon = Wx::Icon->new(16,16,1);

unless(Wx::wxX11){
	$icon->CopyFromBitmap(Wx::Bitmap->new(SAPDB::Install::Resources->new('RESOURCES.TGZ')->
						getImages('icon/uninstall.png')->{'icon/uninstall.png'}->Rescale(16,16)));
}



sub new{
	my ($this ) = shift->SUPER::new(@_);
	$this->SetWindowStyleFlag(wxDEFAULT_DIALOG_STYLE | wxMAXIMIZE_BOX);
	$this->Move([400,300]);
	$this->SetSize([600,450]);
	$this->SetTitle('MaxDB Uninstallation');
	$this->SetIcon($icon);
	my $sizer = Wx::BoxSizer->new(wxVERTICAL);
	$this->{'win'} = SAPDB::Install::Window::Uninstall->new($this,-1);
	$sizer->Add($this->{'win'},1,wxEXPAND);
	$this->{'win'}->init;
	$this->SetSizer($sizer);
	$this->SetAutoLayout(1);
	$this->Layout();
	EVT_CLOSE($this,\&OnClose);
	return $this;
}

sub OnClose{
	my ($self,$evt) = @_;
	my $msgbox = Wx::MessageDialog->new($self,"Do you really want to leave the ".$self->GetTitle."?",
		"Exit?", wxYES_NO | wxNO_DEFAULT  | wxICON_QUESTION | wxCENTRE);
	my $rc = $msgbox->ShowModal();
	$msgbox->Destroy();
	if ($rc == wxID_YES){
		$self->EndModal(wxID_YES);
	}	
	
}

sub GetBestSize{
	my ($self) = @_;
	return $self->GetSize unless defined $self->{'win'};
	return $self->{'win'}->GetBestSize();
}


sub RecalcBestSize{
	my ($self) = @_;
	my $size = $self->GetBestSize;
	my ($width,$height) = ($size->GetWidth,$size->GetHeight);
	$self->SetSizeHints($width,$height); 
	my ($cur_width,$cur_height) = $self->GetSizeWH;
	my $dirty = 0;
	if($cur_width < $width){
		$cur_width = $width;
		$dirty = 1;	
	}
	if($cur_height < $height){
		$cur_height = $height;
		$dirty = 1;	
	}
	if($dirty){
		$self->SetSize([$cur_width,$cur_height]);
		$self->Layout;
	}
	$self->Layout;
}


sub Destroy{
	my ($self) = @_;
	while($self->GetSizer->Remove(0)) {}
	$self->{'win'}->Destroy;
	delete $self->{'win'};
	$self->SUPER::Destroy;
}

sub DESTROY{
	my ($self) =  @_;
	print ">>>> DESTROY $self\n"
		if $SAPDB::Install::DEBUG::DESTRUCT;
}

1;
