#!/usr/bin/perl
#
# $Header: //sapdb/V76/develop/sys/src/install/perl/SAPDB/Install/App.pm#1 $
# $DateTime: 2004/03/11 10:29:37 $
# $Change: 66919 $
#
# Desc: start SAP DB installation/update/patch/instanceupgrade, called by SDBINST/SDBUPD

package SAPDB::Install::Frame::Base;

use Wx::Event qw (EVT_CLOSE);
use Wx qw (wxYES_NO wxCENTRE wxID_YES
	wxICON_QUESTION wxNO_DEFAULT);

use SAPDB::Install::Resources;

our @ISA = qw (Wx::Frame);


our $icon = Wx::Icon->new(16,16,1);

unless(Wx::wxX11){
	$icon->CopyFromBitmap(Wx::Bitmap->new(SAPDB::Install::Resources->new('RESOURCES.TGZ')->
						getImages('icon/install.png')->{'icon/install.png'}));
}


sub new {
  my( $class ) = shift;
  my( $this ) = $class->SUPER::new( undef, -1, $_[0], $_[1], $_[2] );
  
   # load an icon and set it as frame icon
  $this->SetIcon($icon);
  $this->{'IsBeingClosed'} = 0;

  $this->initFrame();		
  EVT_CLOSE( $this, \&OnQuit );
  $this;
}

sub initFrame{
	my ($self) = @_;
	unless(defined $SAPDB::Install::Values::RefreshGui){
		$SAPDB::Install::Values::RefreshGui = sub {Wx::Yield()};
	}

}

sub OnQuit {
	my ($this,$event) = @_;
	return if $this->{'IsBeingClosed'};
	
	unless ($event->CanVeto){
		$this->{'IsBeingClosed'} = 1;
		Wx::Yield();		
		$this->Destroy;		
		return;
	}
	
	my $title = $this->GetTitle;
	$title =~ s/\s*\[.*\].*//; 
	my $msgbox = Wx::MessageDialog->new($this,
				"Do you really want to leave the $title?",
			"Exit?", wxYES_NO | wxNO_DEFAULT  | wxICON_QUESTION | wxCENTRE);
	if ( $msgbox->ShowModal() == wxID_YES){
		$event->Veto(0);
		if (defined $SAPDB::Install::Values::log){
			$SAPDB::Install::Values::log->SetMsg 
					("MSG: user canceled application\n");
		}
		$this->{'IsBeingClosed'} = 1;
		Wx::Yield();
		$this->Destroy;
		if((caller(4))[3] eq 'SAPDB::Install::Frame::Base::__ANON__'){
			
			#
			#	called by RefreshGui() callback function
			#  
			#	throw exception to end application properly
			#
			
			die('SDB_closing');
		}
	}
	else{
		$event->Veto(1);
	}

}

1;
