#!/usr/bin/perl
#
# $Header: //sapdb/V76/c_00/b_34/sys/src/install/perl/SAPDB/Install/Grid/CellProgressBarRenderer.pm#1 $
# $DateTime: 2006/09/04 17:37:38 $
# $Change: 134683 $
#
# Desc: start SAP DB installation/update/patch/instanceupgrade, called by SDBINST/SDBUPD


package SAPDB::Install::Grid::CellProgressBarRenderer;

use base Wx::PlGridCellRenderer;
use Wx qw(wxWHITE);

sub ProcInvisibleTop{
	my ($self,$win,$row_max) = @_;
	return if $row_max < 0;
	foreach my $row (0 .. $row_max){
		if(defined $win->{'bar_'.$row}){
			$win->{'bar_'.$row}->Show(0);
		}
	}
}

sub ProcInvisibleBottom{
	my ($self,$win,$row_min) = @_;
	my $rows = $#{@{$win->{'plan'}}};
	return if $row_min > $rows;
	foreach my $row ( $row_min .. $rows){
		if(defined $win->{'bar_'.$row}){
			$win->{'bar_'.$row}->Show(0);
		}
	}
}


sub Draw {
	my( $self, $grid, $attr, $dc,
		 $rect, $row, $col, $sel ) = ( shift, @_ );

	my $value = $grid->GetCellValue( $row, $col );
	my $win = $grid->GetParent;
	
	my ($new_x,$new_y) = $grid->CalcScrolledPosition($rect->x,$rect->y);

	if($new_y <= 0){
		$self->ProcInvisibleTop($win,$row - 1);
	}
	elsif($new_y > ($grid->GetSize->GetHeight - $rect->GetHeight)){
		$self->ProcInvisibleBottom($win,$row + 1);
	}

	unless($^O !~ /mswin/i or $self->{'bg_set'}){
   		$win->SetBackgroundColour(wxWHITE);
   		$self->{'bg_set'} = 1;
   	}

	my $bar;
	if(defined $win->{'bar_'.$row}){
		$bar = $win->{'bar_'.$row};
		#$bar->Show(0);
		$bar->Show(1);
		if($self->{'x'} != $new_x  or 
			$self->{'y'} != $new_y or
			$self->{'width'} != $rect->GetWidth or 
			$self->{'height'} != $rect->GetHeight
				or $grid->IsExposed($rect)
			){
			if ($self->{'x'} != $new_x  or 
				$self->{'y'} != $new_y){
				$self->SUPER::Draw(@_);
				$bar->Move([$new_x,$new_y + int($rect->GetHeight / 6)]);		
			}
			if($self->{'width'} != $rect->GetWidth or 
				$self->{'height'} != $rect->GetHeight){
				$bar->SetSize([$rect->GetWidth,
								int($rect->GetHeight * 2 / 3 )]);
				
			}
			$self->{'x'} = $new_x;
			$self->{'y'} = $new_y;
			$self->{'height'} = $rect->GetHeight;
			$self->{'width'} = $rect->GetWidth;
				
		}
	}else{
		$self->SUPER::Draw( @_ );
		$bar = Wx::Gauge->new($grid,-1,100,[$new_x,$new_y + int($rect->GetHeight / 6)]
										,[$rect->GetWidth,int($rect->GetHeight  *2 / 3 )]);

		$self->{'x'} = $new_x;
		$self->{'y'} = $new_y;
		$self->{'height'} = $rect->GetHeight;
		$self->{'width'} = $rect->GetWidth;
		$win->{'bar_'.$row} = $bar;
	}	
	if($value != $bar->GetValue()){
		$bar->SetValue($value);
	}
	return 1; 
		
}

#sub GetBestSize{
#	my ($grid, $attr, $dc, $row,$col) = @_;
#	print ">>> starting bestsize\n";
#	my $size = Wx::Size->new(24,24); 
#	#print ">>>>> size = $size\n";
#	#return \$size;
#}

sub Clone {
  my $self = shift;
  return $self->new;
}



sub Destroy{
	my ($self) = @_;
	self->SUPER::Destroy;
}

1;
