#!/usr/bin/perl
#
# $Header: //sapdb/V76/c_00/b_34/sys/src/install/perl/SAPDB/Install/Grid/CellStateIconRenderer.pm#1 $
# $DateTime: 2006/09/04 17:37:38 $
# $Change: 134683 $
#
# Desc: start SAP DB installation/update/patch/instanceupgrade, called by SDBINST/SDBUPD


package SAPDB::Install::Grid::CellStateIconRenderer;

use base Wx::PlGridCellRenderer;
use Wx qw(wxBLACK_PEN wxWHITE_BRUSH wxCOPY);
use SAPDB::Install::Resources;

our $mem_dc = {};
our $is_wxGTK = Wx::wxGTK;

sub Draw {
  my( $self, $grid, $attr, $dc,
		 $rect, $row, $col, $sel ) = ( shift, @_ );
  
  $self->SUPER::Draw( @_ );
  my $value = $grid->GetCellValue( $row, $col );
  my $y = $rect->y;
  unless(exists $mem_dc->{$value}){
	 my $images = (SAPDB::Install::Resources->
				new('RESOURCES.TGZ'))->getImages('icon/ready.png',
												'icon/process.png',
												'icon/error.png');
	$mem_dc->{$value} = Wx::MemoryDC->new();
	$mem_dc->{$value}->BeginDrawing() if $^O =~ /mswin/i;
	if($value eq 'FINISHED_SUCCESS'){
		$mem_dc->{$value}->SelectObject(Wx::Bitmap->new($images->{'icon/ready.png'}));
	}
       elsif($value eq 'RUNNING'){
		$mem_dc->{$value}->SelectObject(Wx::Bitmap->new($images->{'icon/process.png'}));
	
	}
	elsif($value eq 'FINISHED_ERROR'){
		$mem_dc->{$value}->SelectObject(Wx::Bitmap->new($images->{'icon/error.png'}));
  	}
	$mem_dc->{$value}->EndDrawing() if $^O =~ /mswin/i;
  }	  
  my ($icon_width,$icon_height) =  $mem_dc->{$value}->GetSizeWH; 
  my $y_diff = $rect->GetHeight - $icon_height;  
  if($y_diff > 0){
	$y += int($y_diff/2); 
  }	
 $dc->Blit($rect->x + 20,$y,$mem_dc->{$value}->GetSizeWH,$mem_dc->{$value},0,0,wxCOPY,1);
  	
}

sub GetBestSize{
	my ($self) = @_;
	foreach my $key (%$mem_dc){
		return  $mem_dc->{$key}->GetSize();
	}
}

sub Clone {
  my $self = shift;
  return $self->new;
}
1;
