#!/usr/bin/perl
#
# $Header: //sapdb/V76/c_00/b_34/sys/src/install/perl/SAPDB/Install/Menu/Base.pm#1 $
# $DateTime: 2006/09/04 17:37:38 $
# $Change: 134683 $
#
# Desc: 

package SAPDB::Install::Menu::Base;

use Wx::Event qw ();

use Wx qw (wxITEM_NORMAL);

use base Wx::Menu;
use SAPDB::Install::Resources;
use SAPDB::Install::Image;

our $members = {};

sub new{
	my $class = shift;
	my ($self ) = $class->SUPER::new(@_);
	$self = bless($self,$class);
	$members->{$self}->{'menu_items'} = {};
	#$self->InitItems();
	return $self;
}

sub InitItems{
	my ($self,$item_desc) = @_;
	return undef unless ref ($item_desc) eq 'ARRAY';
	my $items = $members->{$self}->{'menu_items'};
	my $id = 1;
	foreach my $desc (@$item_desc){
		unless (ref ($desc) eq 'HASH'){
			$self->AppendSeparator();
			next;
		}
		$items->{$id} = Wx::MenuItem->new(	$self,
											$id,
											$desc->{'label'},
											$desc->{'help'},
											wxITEM_NORMAL,
											$desc->{'submenu'});	
		my $images;									
		if (exists $desc->{'image'}){
			$images = SAPDB::Install::Resources->new('RESOURCES.TGZ');	
			unless (exists $images->{$desc->{'image'}}){
				$images->readAll;
			}
		}
		
		if (exists $desc->{'image'} and 
			exists $images->{$desc->{'image'}}){
			if (exists $desc->{'disable'} and $desc->{'disable'}){
				unless (exists $images->{$desc->{'image'}.'_disable'}){
					$disable_image = $images->{$desc->{'image'}}->Copy();
					$disable_image->Disable();										
					$images->{$desc->{'image'}.'_disable'} = $disable_image; 
					
				}
				$items->{$id}->SetBitmap(Wx::Bitmap->new($images->{$desc->{'image'}.'_disable'}));
			}
			else{
				$items->{$id}->SetBitmap(Wx::Bitmap->new($images->{$desc->{'image'}}));
			}
		}
		$self->Append($items->{$id});		 
		if (exists $desc->{'disable'} and $desc->{'disable'}){
			$items->{$id}->Enable(0);
		}
		$id++;	
	}
}

sub Destroy{
	my ($self) = @_;
	my $items = $members->{$self}->{'menu_items'};
	foreach my $item (keys (%$items)){
		$items->{$item}->Destroy;
	}
	delete $members->{$self};
	$self->SUPER::Destroy;
}

sub DESTROY{
	my ($self) = @_;
	print ">>>> DESTROY $self\n"
		if $SAPDB::Install::DEBUG::DESTRUCT;
}

1;