#!/usr/bin/perl
#
# $Header: //sapdb/V76/c_00/b_34/sys/src/install/perl/SAPDB/Install/Portable/RegCommands.pm#1 $
# $DateTime: 2006/09/04 17:37:38 $
# $Change: 134683 $
#
# Desc: functions to create MaxDB RTE Registrations in portable mode
#		This module can be replaced if MaxDB register commands work in portable mode 

package SAPDB::Install::Portable::RegCommands;

require SDB::Common::Exporter;
our @ISA = qw (SDB::Common::Exporter);

our @EXPORT = qw ( SdbConfig );	


use SAPDB::Install::Registry;
use SAPDB::Install::Values;
use SAPDB::Install::System;
use SAPDB::Install::Portable::Helper;




#
# register Independent Data, Independent Programs,
# SDBOwner, SDBAGroup 
#

sub SdbConfig{
	my ($arg_line) = @_;
	return undef 
		unless (exists $SAPDB::Install::Config{'SDB_PORTABLE_ROOT'});
	my $regfile = $SAPDB::Install::Config{'SDB_PORTABLE_ROOT'}.$SAPDB::Install::Values::glob_path;
	
	my ($regdir) = ($regfile =~ /^(.+)[\\\/][^\\\/]+$/);
	
	unless (-d $regdir){
		makedir ($regdir,0755);
	}
	
	my $section = 'Globals';
		
	my $struct = {};
	
	my @result;
	
	if ($arg_line =~ /=/){
		# set mode
		my ($key,$value) = ($arg_line =~ /(.+)=((.*))/);
		
		$key =~ s/^\s*//;
		$key =~ s/\s*$//;
		$value =~ s/^\s*//;
		$value =~ s/\s*$//;
		my $rel_path = getRelPath ($value,$key =~ /IndepData/);
		if (defined $rel_path){
			$value = $rel_path;
		}		
				
		if ($value =~ /\S/){
			$struct->{'add_key'}->{$section}->{$key} = $value;
		}
		else{
			$struct->{'delete_key'}->{$section}->{$key};
		}
		unless (writeini ($regfile,$struct)){
			return undef;
		}	
	}
	else{
		# get mode
		return undef unless -f $regfile;
		my %globs = readini($regfile);
		unless (exists $globs{$section}){
			return undef;
		}		
		
		if ($argline !~ /\S/){
			# get all entries;
			foreach my $key (keys (%{$globs{$section}})){
				push @result,$key.'='.getAbsPath ($globs{$section}->{$key}, $key =~ /data/i);
			} 		
		}
		else {
			foreach my $key (keys (%{$globs{$section}})){
				if ($key eq $argline){
					push @result,$key.'='.getAbsPath ($globs{$section}->{$key}, $key =~ /data/i);
				}
			}  
		}
		return \@result;
	}	
	return 1;
}


1;

