#!/usr/bin/perl

package SAPDB::Install::Templates::MobileWorkstation;

#ifdef SCRIPTING
#use strict;
#use SAPDB::Install::Templates::Template;
#use SAPDB::Install::Templates::MobileInfra;
#use SAPDB::Install::Templates::Util;
#use SAPDB::Install::Registry;
#use SAPDB::Install::System::Win32::Registry ;
#require Exporter;
#our @ISA = qw( Exporter  SAPDB::Install::Templates::Template );
#our @EXPORT = qw(
#                );
#endif

#because SDBINST

our @ISA = qw(SDB::Common::Exporter SAPDB::Install::Templates::Template);
use SAPDB::Install::Templates::Template;
use SAPDB::Install::Templates::Util;
use SAPDB::Install::Templates::MobileInfra;
use SAPDB::Install::Registry;

#endbecause

#ifdef doc
#<h1>SAPDB::Install::Templates::MobileWorkstation</h1>
#  <p>
#  Mobile Infrastructure: Workstation Installation
#  </p>
  #endif
  sub new(){
    my $this =    
      {
      };
    bless $this;
    $this->setDefaults();
    $this->setTemplateCode("templ_mi_workstation");
    return $this;
  }#new


sub createParameterTemplates{
my ($this) = @_;
my $ps     = {
              "INSTANCE.DBNAME" =>
     [
      undef,
      "MIDB1",
      undef,
      undef,
      undef ,
      undef
     ]
  };
return mergeParameterTemplates($this->SUPER::createParameterTemplates(),$ps);
}




#+sub(Frame:previousFrame):Frame:Liefert die anzuzeigenden Frames in der richtigen Reihenfolge
sub nextFrame{
  my ($this,$previousFrame) = @_;
  my $nextFrame=undef;
  if (defined $previousFrame) {
  } else {
    my $template = SAPDB::Install::Templates::MobileInfra::new();
    $this->setDBInstance($template);
    $this->setIsCreateInstance(1);
    $nextFrame = $this->createFrameDescription("MiWorkstation");
  }
  #else
  return $nextFrame;
}
#nextFrame



sub createTemplateOverView{
  my ($this) = @_;
  my $descs = $this->SUPER::createTemplateOverView();

  my $own =  [
              $this->createFrameDescription("MiWorkstationDescription1")
             ];

  push @$descs, @$own; 
  return $descs;
}


sub createFrameTemplates{
my ($this) = @_;
my $frs = 
  {
   "MiWorkstation" =>  
   {
    "Title" => "Specify database name and installation drive",
    "FrameId" => "MiWorkstation",
    "Data" => {  },
    "MetaData" => 
    {
     "INSTANCE.DRIVE" ,{"priority" => 1},
     "INSTANCE.DBNAME",{"priority" => 0}
    }
   },

   "MiWorkstationDescription1" =>  
   {
    "Title" => "Database Parameters",
    "FrameId" => "MiWorkstationDescription1",
    "Data" => {  },
    "MetaData" => 
    {
     "INSTANCE.DBNAME",{"priority" => 0},
     "INSTANCE.DBSIZE",{"priority" => 1},
     "INSTANCE.LOG_AUTO_OVERWRITE",{"priority" => 2},
     "INSTANCE.AUTORESTART",{"priority" => 3}
    }
   }
  };
return mergeFrameTemplates($this->SUPER::createFrameTemplates(),$frs);
}


sub configure{
  my ($this ) = @_;
  my @configResult = (1);
  @configResult = $this->SUPER::configure();
  my $instance = $this->getDBInstance();
  if($instance){
    my $volcount = $instance->getDataVolCount();
    my $volsize = $instance->getDataSize();
    my $size = $volcount * $volsize;
    $instance->setDBSize($size);
  }
  return @configResult;
}

sub initialize{
  my ($this ) = @_;
  $this->SUPER::initialize();
  my $instance = $this->getDBInstance();
  if($instance){
    my $aSize = $instance->getDBSize();
    unless ($aSize){
      my $volcount = $instance->getDataVolCount();
      my $volsize = $instance->getDataSize();
      my $size = $volcount * $volsize;
      $instance->setDBSize($size);
    }
  }
}





1;








# Local Variables: ***
# perl-dbg-flags:"-w      -I../../../../../../wrk/script -I../../../sdbrun  " ***
# sdbinst-defines: "-define SCRIPTING=YES -define PERL5.6.1=YES" ***
# sdbinst-testfile: "TemplateTest.pl" ***
# sdbinst-script-directory:  "sys/wrk/script/SAPDB/Install/Templates" ***
# End: ***

