package  SAPDB::Install::Templates2::test::DatabaseInstanceTestInstallation;
use SAPDB::Install::Templates2::InstUnit;
use SAPDB::Install::Templates2::InstTemplate;
use SAPDB::Install::Templates2::Debug;
use SAPDB::Install::Templates2::Util;
use SAPDB::Install::Templates2::test::DatabaseInstanceGeneric;
use strict;


our @ISA;
if($SCRIPTING){
  require Exporter;
  push @ISA,qw(Exporter);
}
else{
  require SDB::Common::Exporter;
  push @ISA,qw(SDB::Common::Exporter);
}
our @EXPORT = qw (allTests);


my ($db); 
sub setUp{
  $db = SAPDB::Install::Templates2::test::DatabaseInstanceGeneric::new() or die;
  my $template = $db->getInstTemplate();
  push @{$template->GetListeners('log')},(sub {Logit($_[0]);});
  push @{$template->GetListeners('warning')},(sub {Logit( "WARNING: " . $_[0]);});
  push @{$template->GetListeners('debug')},(sub{Debugit(@_);});
  push @{$template->GetListeners('async_status')},(sub{Statusit(@_);});
  $template->setStatusListCallback(sub{
                                 my $lst = shift;
                                 my $current = $lst->[0];
                                 foreach(@$lst){
                                   'PENDING' eq $_->{'Status'} and last;
                                   $current = $_;
                                 }
                                 Logit('>>'.$current->{'Status'}.': '. $current->{'Label'});
                               });
}

sub tearDown{
  undef $db;
}

sub testCreateInstance{
  $db->setAutoRestart(0);
  $db->setAutoUpdateStatistics(0);
  $db->setAutoExtend(0);
  $db->setLoadSampleSchema(0);
  my $retVal = $db->createInstance();
  $retVal and Logit($retVal);
  $retVal = $db->deleteInstance();
  return $retVal;
}





sub allTests{
  unitTest(__PACKAGE__);
}

1;


# Local Variables: ***
# eval: (setq my-sdbrun (format "%s\\sys\\src\\install\\perl\\sdbrun" "c:\\SapDevelop\\aw")) ***
# eval: (setq my-script (format "%s\\sys\\wrk\\script" "c:\\SapDevelop\\aw")) ***
# eval: (setq my-src (format "%s\\sys\\src\\install\\perl" (sdb-get-current-own))) ***
# eval: (setq perl-dbg-flags (format "-w -I%s -I%s\\readkey -I%s -I%s" my-sdbrun my-sdbrun my-script my-src )) ***
# End: ***
