package   SAPDB::Install::Templates2::test::InstUnitTest;

use SAPDB::Install::Templates2::InstUnit;
use SAPDB::Install::Templates2::InstTemplate;
use SAPDB::Install::Templates2::Debug;
use SAPDB::Install::Templates2::Util;
use SAPDB::Install::Templates2::Archiver;

use SAPDB::Install::Untgz;
use strict;



our @ISA;
if($SCRIPTING){
  require Exporter;
  push @ISA,qw(Exporter);
}
else{
  require SDB::Common::Exporter;
  push @ISA,qw(SDB::Common::Exporter);
}
push  @ISA, qw( SAPDB::Install::Templates2::InstUnit);
our @EXPORT = qw (allTests);


sub new{
  my ($aTemplate) = @_;
  my $data = {
              'CLASS' => 'SAPDB::Install::Templates2::test::InstUnitTest',
              'PACKAGE_NAME' => 'InstUnitTestPackage'
             };
  my $instunit =  SAPDB::Install::Templates2::InstUnit::new($data,$aTemplate);
  return $instunit;
}


my $templateFile ;
my ($instunit,$template );
sub setUp{
  $template = SAPDB::Install::Templates2::InstTemplate::new($templateFile);
  $instunit = new ($template)  or die;
}


sub tearDown{
  undef $template;
  undef $instunit;
}


sub testSetIndepProg{
  $instunit->setIndepProg("c:\\testvalue");
  my $p1 = $instunit->getIndepProg();
  my $p2 = $template->getIndepProg();
  $p2 eq $p1 or return "Wrong values '$p1' <-> '$p2'";
  return 0;
}

sub testSetIndepData{
  $instunit->setIndepData("c:\\testvalue");
  my $p1 = $instunit->getIndepData();
  my $p2 = $template->getIndepData();
  $p2 eq $p1 or return "Wrong values '$p1' <-> '$p2'";
  return 0;
}

sub testSetSystemProgPath{
  $instunit->setSystemProgPath("c:\\testvalue");
  my $p1 = $instunit->getSystemProgPath();
  my $p2 = $template->getSystemProgPath();
  $p2 eq $p1 or return "Wrong values '$p1' <-> '$p2'";
  return 0;
}

sub testSetUser{
  $instunit->setUser("testuser");
  my $p1 = $instunit->getUser();
  my $p2 = $template->getOwnerName();
  $p2 eq $p1 or return "Wrong values '$p1' <-> '$p2'";
  return 0;
}

sub testSetGroup{
  $instunit->setGroup("testgroup");
  my $p1 = $instunit->getGroup();
  my $p2 = $template->getOwnerGroup();
  $p2 eq $p1 or return "Wrong values '$p1' <-> '$p2'";
  return 0;
}





sub allTests{
  $templateFile = shift;
  unitTest(__PACKAGE__);
}


1;

# Local Variables: ***
# eval: (setq my-sdbrun (format "%s\\sys\\src\\install\\perl\\sdbrun" "c:\\SapDevelop\\aw")) ***
# eval: (setq my-script (format "%s\\sys\\wrk\\script" "c:\\SapDevelop\\aw")) ***
# eval: (setq my-src (format "%s\\sys\\src\\install\\perl" (sdb-get-current-own))) ***
# eval: (setq perl-dbg-flags (format "-w -I%s -I%s\\readkey -I%s -I%s" my-sdbrun my-sdbrun my-script my-src )) ***
# End: ***
