package SAPDB::Install::Templates2::test::InstanceDesktopTestInstallation;
use SAPDB::Install::Templates2::InstUnit;
use SAPDB::Install::Templates2::InstTemplate;
use SAPDB::Install::Templates2::Debug;
use SAPDB::Install::Templates2::Util;
use strict;


our @ISA;
if($SCRIPTING){
  require Exporter;
  push @ISA,qw(Exporter);
}
else{
  require SDB::Common::Exporter;
  push @ISA,qw(SDB::Common::Exporter);
}


require Exporter;
push @ISA,qw(Exporter);
our @EXPORT = qw ( allTests );

my ($db,$tpl); 
sub setUp{
  $tpl = SAPDB::Install::Templates2::InstTemplate::new(undef,'desktop') or die;
  $db = $tpl->getDBInstance();
  push @{$tpl->GetListeners('log')},(sub {Logit($_[0]);});
  push @{$tpl->GetListeners('warning')},(sub {Logit( "WARNING: " . $_[0]);});
  push @{$tpl->GetListeners('debug')},(sub{Debugit(@_);});
  push @{$tpl->GetListeners('async_status')},(sub{Statusit(@_);});
  $tpl->setStatusListCallback(sub{
#                                print $db->getStatusList(),"\n";
                              } 
                             );
}

sub tearDown{
  undef $tpl;
  undef $db;
}

sub testCreateInstance{
  my $retVal = $db->createInstance();
  $retVal and Logit($retVal);
  $retVal = $db->deleteInstance();
  return $retVal;
}


sub allTests{
  unitTest(__PACKAGE__);
}


1;





# Local Variables: ***
# eval: (setq my-sdbrun (format "%s\\sys\\src\\install\\perl\\sdbrun" "c:\\SapDevelop\\aw")) ***
# eval: (setq my-script (format "%s\\sys\\wrk\\script" "c:\\SapDevelop\\aw")) ***
# eval: (setq my-src (format "%s\\sys\\src\\install\\perl" (sdb-get-current-own))) ***
# eval: (setq perl-dbg-flags (format "-w -I%s -I%s\\readkey -I%s -I%s" my-sdbrun my-sdbrun my-script my-src )) ***
# End: ***
