package  SAPDB::Install::Templates2::test::InstanceJ2EETestInstallation;
use SAPDB::Install::Templates2::InstUnit;
use SAPDB::Install::Templates2::InstTemplate;
use SAPDB::Install::Templates2::Debug;
use SAPDB::Install::Templates2::Util;

our @ISA;
if($SCRIPTING){
  require Exporter;
  push @ISA,qw(Exporter);
  require Data::Dumper; 
  import Data::Dumper;
}
else{
  require SDB::Common::Exporter;
  push @ISA,qw(SDB::Common::Exporter);
}


require Exporter;
push @ISA,qw(Exporter);
our @EXPORT = qw ( allTests );


my ($db,$tpl); 
my $configFile;
sub setUp{
  $tpl = SAPDB::Install::Templates2::InstTemplate::new(undef,'sapdw') or die;
  $db = $tpl->getDBInstance();
  push @{$tpl->GetListeners('log')},(sub {Logit($_[0]);});
  push @{$tpl->GetListeners('warning')},(sub {Logit( "WARNING: " . $_[0]);});
  push @{$tpl->GetListeners('debug')},(sub{Debugit(@_);});
  push @{$tpl->GetListeners('async_status')},(sub{Statusit(@_);});
}

sub tearDown{
  undef $tpl;
  undef $db;
}


sub testCreateInstance{


my $testVolumes =
  [
   "1;DATA;\${SOFTWAREPATH}/\${DBNAME}/data/DISKD0001;F;13107",
   "1;LOG;\${SOFTWAREPATH}/\${DBNAME}/log/DISKL0001;F;12800"
  ];

  #Reduce size to ease installation test:
  $db->setDBVolume($testVolumes);
  #Create instance
  my $retVal = $db->createInstance();

  $retVal = $db->deleteInstance();
  return $retVal;
}


sub allTests{
  $configFile = shift;
  unitTest(__PACKAGE__);
}


1;

# Local Variables: ***
# eval: (setq my-sdbrun (format "%s\\sys\\src\\install\\perl\\sdbrun" "c:\\SapDevelop\\aw")) ***
# eval: (setq my-script (format "%s\\sys\\wrk\\script" "c:\\SapDevelop\\aw")) ***
# eval: (setq my-src (format "%s\\sys\\src\\install\\perl" (sdb-get-current-own))) ***
# eval: (setq perl-dbg-flags (format "-w -I%s -I%s\\readkey -I%s -I%s" my-sdbrun my-sdbrun my-script my-src )) ***
# End: ***
