package SAPDB::Install::Templates2::test::InstanceMobileClientTest;

use SAPDB::Install::Templates2::Debug;
use SAPDB::Install::Templates2::InstTemplate;
use SAPDB::Install::Templates2::Util;
use SAPDB::Install::Templates2::CmdLine;
use strict;

our @ISA;
if($SCRIPTING){
  require Exporter;
  require Data::Dumper;
  import Data::Dumper;
  push @ISA,qw(Exporter);
}
else{
  require SDB::Common::Exporter;
  push @ISA,qw(SDB::Common::Exporter);
}
require Exporter;
push @ISA,qw(Exporter);
our @EXPORT = qw ( allTests );

my ($sapmc_archive,$sapmc,$sapmc_archive_template, $sapmc_template,$cmdLine);
sub setUp{
  $sapmc_archive_template = SAPDB::Install::Templates2::InstTemplate::new(undef,'sapmds') or die;
  $sapmc_archive = $sapmc_archive_template->getDBInstance();

  $sapmc_template = SAPDB::Install::Templates2::InstTemplate::new(undef,'sapmc') or die;
  $sapmc = $sapmc_template->getDBInstance();



  $cmdLine = newCmdLine();
}

sub tearDown{
 undef $sapmc_archive;
 undef $sapmc;

 undef $sapmc_template;
 undef $sapmc_archive_template;

 undef $cmdLine;
}


sub testGetDBName{
  my ($info,$retVal,$s) ;
  $s = $sapmc_archive->GetDefault('dBName');
#  print "$s\n";
#  $retVal = $cmdLine->show('mobile',\$info) and return $retVal;
#  print "$info\n";
  return 0;
}

sub testGetDBVolume{
  my $vols = $sapmc_archive->getDBVolume();
#  print Dumper($vols);
  return 0;
}

sub testValidateDBName{
  return 0;
}

sub testValidate{
  return 0;
}

sub testGetDependendPath{
  my $s = $sapmc->getDependendPath();
#  print $s . "\n";
  return 0;
}


sub testGetDBParam{
  my $p = $sapmc_archive->getDBParams();
#  print Dumper($p);
  return 0;
}
sub testGetInstanceArchive{
  my $s = $sapmc_archive_template->getInstanceArchive();
  $s =~ /IASDB.TGZ$/ or return "Wrong instance archive: $s";
  return 0;
}

sub testGetIndepProg{
  my $s = $sapmc_archive_template->getIndepProg();
  my $rs = 'C:\sdb\programs';
  unless($sapmc_archive_template->getIsIndepProgRegistered()){
    $s eq $rs or return "Wrong indepprog: '$s',expected '$rs'";
  }
  $s = $sapmc_template->getIndepProg();
  return 0;
}

sub testGetIndepData{
  my $s = $sapmc_archive_template->getIndepData();
  my $rs = 'C:\sdb\data';
  unless($sapmc_archive_template->getIsIndepDataRegistered()){
    $s eq $rs or return "Wrong indepprog: '$s',expected '$rs'";
  }
  return 0;
}


sub testValidateIndepProg{
  return testValidateSomething
    (
     {'c:\sdb\Programs' => 1,
      'f:\sdb\programs' => 1,
      'f:\sdb\program' => 0,
      'f:\sdb\sdffsprograms' => 0,
      '  ' => 0
     },
     *SAPDB::Install::Templates2::MobileClientTemplate::validateIndepProg,
     $sapmc_archive_template
    );
}


sub testValidateIndepData{
  return testValidateSomething
    (
     {'c:\sdb\data' => 1,
      'f:\sdb\DATA' => 1,
      'f:\sdb\dat' => 0,
      'f:\sdb\sdffsprograms' => 0,
      '  ' => 0
     },
     *SAPDB::Install::Templates2::MobileClientTemplate::validateIndepData,
     $sapmc_archive_template
    );
}



sub testValidateSomething{
  my ($paths,$functionPointer,$sapmc_archive_template) = @_;
  my $s;
  foreach(keys %$paths){
   $s = &$functionPointer($sapmc_archive_template,$_);
   $s and $paths->{$_} and return "Assertion failed for $functionPointer:\n $_ ($s)";
  }
  return 0;
}






sub testSetDrive{
  $sapmc_archive_template->setDrive('f');
  my $s = $sapmc_archive_template->getIndepProg();
  $s = $sapmc_archive_template->getIndepData();
  $s = $sapmc_archive->getDependendPath();
#  print "$s\n";
  return 0;
}

sub allTests{
  unitTest(__PACKAGE__);
}

1;


# Local Variables: ***
# eval: (setq my-sdbrun (format "%s\\sys\\src\\install\\perl\\sdbrun" "c:\\SapDevelop\\aw")) ***
# eval: (setq my-script (format "%s\\sys\\wrk\\script" "c:\\SapDevelop\\aw")) ***
# eval: (setq my-src (format "%s\\sys\\src\\install\\perl" (sdb-get-current-own))) ***
# eval: (setq perl-dbg-flags (format "-w -I%s -I%s\\readkey -I%s -I%s" my-sdbrun my-sdbrun my-script my-src )) ***
# End: ***
