#!/usr/bin/perl
#
# $Header: //sapdb/V76/c_00/b_34/sys/src/install/perl/SAPDB/Install/User/SyncMan/Config.pm#1 $
# $DateTime: 2006/09/04 17:37:38 $
# $Change: 134683 $
#
# Desc: 

package SAPDB::Install::User::SyncMan::Config;

use SDB::Common::Getopt::Long;
use SAPDB::Install::System;
use SAPDB::Install::StdIO;

sub main{
	local @ARGV = @_;
	my ($config_file,$opt_config_type,
		$opt_accesskey,$opt_file,$opt_user,
		$opt_database);
	my %options = (
		'configfile=s' => \$opt_file,
		'config=s' => \$opt_config_type,
		'A=s' => \$opt_accesskey,
		'd=s' => \$opt_database
	);
	unless(GetOptions(%options)){
		print STDERR "wrong usage\n";
		return -1;
	}
	
	if($opt_file =~ /\S/){
		$config_file = $opt_file;
		$config_file =~ s/\\/\//g if $^O =~ /mswin/i;
	}
			
	my %init = (
		'config_file' => $opt_file,
		'accesskey' => $opt_accesskey,
		'database' => $opt_database
	);
	
		
	if($opt_config_type eq 'JAVA'){
		require SAPDB::Install::User::SyncMan::Config::Java;
		$config = SAPDB::Install::User::SyncMan::Config::Java->new(\%init);
	
	}
	elsif($opt_config_type eq 'MSGSERVER'){
		require SAPDB::Install::User::SyncMan::Config::MsgServer;
		$config = SAPDB::Install::User::SyncMan::Config::MsgServer->new(\%init);
	}
	elsif($opt_config_type eq 'SYNCSERVICE'){
		require SAPDB::Install::User::SyncMan::Config::SyncService;
		$config = SAPDB::Install::User::SyncMan::Config::SyncService->new(\%init);
	}
	else{
		print STDERR ("CONFIG TYPE UNKNOWN\n");
		return -1;
	}
	$config->load();
	$config->console_input();		
	unless($config->write()){
		print STDERR "cannot write configuration\n";
		return -1;
	}		
	return 0;	
}
1;