#!/usr/bin/perl
#
# $Header: //sapdb/V76/c_00/b_34/sys/src/install/perl/SAPDB/Install/Window/Version.pm#1 $
# $DateTime: 2006/09/04 17:37:38 $
# $Change: 134683 $
#
# Desc: start SAP DB installation/update/patch/instanceupgrade, called by SDBINST/SDBUPD


package SAPDB::Install::Window::Version;

use Wx qw(wxWHITE wxVERSION_STRING);
use Wx::Grid;
use SAPDB::Install::Version; 

our @ISA = qw(Wx::Grid);

sub new{
	my($this ) = shift->SUPER::new(@_);
	$this->SetBackgroundColour(wxWHITE);
	my $wx_platform;
	if(Wx::wxX11){
		$wx_platform = 'wxX11';
	}
	elsif(Wx::wxMSW){
		$wx_platform = 'wxMSW';
	}
	elsif(Wx::wxGTK){
		$wx_platform = 'wxGTK';
	}
	elsif(Wx::wxMOTIF){
		$wx_platform = 'wxMOTIF';
	}

	if(Wx::wxUNIVERSAL){
		$wx_platform .= ' wxUNIVERSAL';
	}
	
	my @versions = (
		#'MaxDB Version (long)' => '7.6.00   Build 000-103-069-660',
		#['Version','7.6.00.00'],
		#['State','DEV'],
		#'MaxDB Purpose' => 'OLTP & liveCache',
		['SDBRUN version',$SAPDB::Install::Config{'BinaryInstVersion'}],
		['SDBRUN make id',$SAPDB::Install::Config{'BinaryMakeId'}],
		['SDBRUN buildstring ',$SAPDB::Install::Config{'BinaryBuildString'}],
		
		['Module archive version',$SAPDB::Install::Version::Version],
		['Module archive make id',$SAPDB::Install::Version::MakeId],
		['Module archive buildstring ',$SAPDB::Install::Version::Buildstring],
		
		['Embedded Perl Version',join('.',unpack('UUUU',$^V))],
		['wxWidgets Platform',$wx_platform],
		['wxWidgets Version',wxVERSION_STRING()],
		['wxPerl Version',$Wx::VERSION]
	);
	
	$this->CreateGrid($#versions + 1,2);
	$this->SetColSize( 0, 150 );
	$this->SetColSize( 1, 150 );
	$this->SetRowLabelSize(0);
	$this->SetColLabelSize(0);
	$this->EnableEditing(0);
	$this->SetCellHighlightPenWidth(0);
	$this->DisableDragGridSize;
	
	
	#$this->SetSize([320,$this->GetRowSize(0) * ($#versions + 1)]);
	
	for my $row (0 .. $#versions){
		foreach my $col (0,1){
			#$this->SetReadOnly($row,$col,1);
			$this->SetCellValue($row,$col, $versions[$row]->[$col]);
		}
	}
	$this->Fit;
	return $this;
}

sub Destroy{
	my ($self) = @_;
	$self->SUPER::Destroy;
}


1;
