#!/usr/bin/perl
#
# $Header: //sapdb/V76/c_00/b_34/sys/src/install/perl/SAPDB/Install/Wizard/Dialog/UninstSummary.pm#1 $
# $DateTime: 2006/09/04 17:37:38 $
# $Change: 134683 $
#
# Desc: Installation summary 
# 
#

package SAPDB::Install::Wizard::Dialog::UninstSummary;

use Wx qw (
	wxALL wxVERTICAL wxEXPAND);

use SAPDB::Install::Tools;

use base SAPDB::Install::Wizard::Dialog::Base;

sub new {
	my ($this) = shift->SUPER::new(@_);
	return $this;
}



sub init{
	my ($self,$config) = @_;
	$self->GetWizard->SetInstallMode(1,'&Uninstall');
	$self->{'tree_ctrl'} = Wx::TreeCtrl->new($self,-1,[0,0],[200,200]);
	$self->{'root_node'} = $self->{'tree_ctrl'}->AddRoot('MaxDB Uninstallation',-1,-1);
	$self->{'tree_ctrl'}->SetItemBold($self->{'root_node'},1);

	my $node = $self->{'root_node'};
	
	my $node = $self->{'tree_ctrl'}->AppendItem($self->{'root_node'},'Software Components',-1,-1);
	$self->{'tree_ctrl'}->SetItemBold($node,1);

	
	#
	#	software components
	#
	
	my $dependent_path;

	my $package_count = 0;

	#my $node = $self->{'tree_ctrl'}->AppendItem($node,'Components',-1,-1);
	
	my $size = 0;
		
	foreach my $package_id (@{$config->{'collector'}->GetRegPackageList}){
		
		my $package_infos = $config->{'collector'}->{'regpackage_index'}->{$package_id->[0]}->{$package_id->[1]};
			
		$package_count++;
					
		if(defined $package_infos->{'SIZE'}){
			$size += $package_infos->{'SIZE'};
		}
		
		my $size = '';
		if($package_infos->{'SIZE'} > 0){
			my $bytes = $package_infos->{'SIZE'};
			$size = int(100 * $bytes / 1024 / 1024);
			$size =~ s/(\d\d)$/\.$1\ MB/;
			$size =~ s/^\./0\./;
			$size = ' ('.$size.')';	
		}
		
		my $node = $self->{'tree_ctrl'}->AppendItem($node,
							$package_infos->{'DISPLAY_NAME'}.$size,-1,-1);
		
		$self->{'tree_ctrl'}->AppendItem($node,'Version: '.
											$package_infos->{'SOFTWARE_VERSION'},-1,-1);
		if(defined $package_infos->{'MODE'}){
			$self->{'tree_ctrl'}->AppendItem($node,'Object Mode: '.
												$package_infos->{'MODE'}.' bit',-1,-1);
		}
		if(defined $package_infos->{'BUILD_STRING'}){
			my $build_info = getBuildStringInfo($package_infos->{'BUILD_STRING'});		
			
			if(defined $build_info){
				$self->{'tree_ctrl'}->AppendItem($node,'Purpose: '.
												$build_info->{'purpose'},-1,-1);
				$self->{'tree_ctrl'}->AppendItem($node,'QA Level: '.
												$build_info->{'qa_level'},-1,-1);
				$self->{'tree_ctrl'}->AppendItem($node,'Make Type: '.
												$build_info->{'make_type'},-1,-1);
				$self->{'tree_ctrl'}->AppendItem($node,'Changelist ID: '.
												$build_info->{'changelist'},-1,-1);
								
			}
		
		}
		if(defined $package_infos->{'MAKE_ID'}){
			$self->{'tree_ctrl'}->AppendItem($node,'Make ID: '.
												$package_infos->{'MAKE_ID'},-1,-1);
		}
		#$self->{'tree_ctrl'}->Expand($node);
		$self->{'tree_ctrl'}->SetItemBold($node,1);
	}
	
	if($size > 0){
		my $size_string = int(100 * $size / 1024 / 1024);
		$size_string =~ s/(\d\d)$/\.$1\ MB/;
		$size_string =~ s/^\./0\./;
		$size_string = ' ('.$size_string.')';	
		$self->{'tree_ctrl'}->SetItemText($node,$self->{'tree_ctrl'}->GetItemText($node).$size_string);	
	}	
	#$self->{'tree_ctrl'}->Expand($node);
	$self->{'tree_ctrl'}->SetItemBold($node,1);	

	
	
	if($package_count == 0){
		$self->GetWizard->{'nbutton_disabled'} = 1;
	}

	$self->{'tree_ctrl'}->Expand($node);
	$self->{'tree_ctrl'}->Expand($self->{'root_node'});

	my $sizer = Wx::BoxSizer->new(wxVERTICAL);
	
	$sizer->Add($self->{'tree_ctrl'},1,wxEXPAND | wxALL,20);
	$self->SetSizer($sizer);
	$self->SetAutoLayout(1);
	$self->Layout;
	$self->{'initialized'} = 1;
	return {};
}


sub Process{
	my ($self,$config) = @_;
	return 1;
}

sub Back{
	my ($self) = @_;
	$self->GetWizard->SetInstallMode(0);
	delete $self->GetWizard->{'nbutton_disabled'};
	if($self->{'initialized'}){
		while($self->GetSizer->Remove(0)){}
		$self->{'tree_ctrl'}->Destroy;
		delete $self->{'tree_ctrl'};
		delete $self->{'initialized'};
	}
	return 1;
}


sub Destroy{
	my ($self) = @_;
	if(defined $self->GetSizer){
			while($self->GetSizer->Remove(0)){};
	}
	if(defined $self->{'tree_ctrl'}){
		$self->{'tree_ctrl'}->Destroy;
		delete $self->{'tree_ctrl'};
	}
	$self->SUPER::Destroy;
}

sub DESTROY{
	my ($self) = @_;
	print ">>>> destroying $self\n"
		if $SAPDB::Install::DEBUG::DESTRUCT;
}


1;
